	.area text(rom,rel)
	.dbfile ..\..\..\..\..\..\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParser.c
	.dbfile C:\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParser.c
	.dbfunc e gpsStart _gpsStart fI
;            Pin -> R4
_gpsStart::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 35
; /*
; GPS function file for use with the header file. 
; 3/22/09
; By TJ Johnson
; 
; This program parses the avliable NEMA string data from a GPS unit and displays 
; it to the terminal at a baud of 57600. 
; 
; The terminal display is optimized for the PST terminal avliable from parallax's 
; website.
; 
; For use with the parallax GPS unit, the /raw pin should be connected to ground.
; 
; See end of file for MIT License.
; 
; */
; #include <propeller.h>
; #include <string.h>
; #include <STDLIB.h>
; #include "FdSerial.h"
; #include "gpsParser.h"
; 
; //Global Constants
; 
; 
; 
; // Global Variables
; static int GPSPIN, cogId;
; static char time[8],valid, lat[12], lon[12],speed[8], heading[8], date[8],sats[4],
; 	  horisontalAcc[5], alt[8];
; static long stack[50];
; 
; //Function Implementation
; int gpsStart(int Pin)
; {
	.dbline 36
; FdSerial_start(Pin, -1, 0,4800);  //Start FdSerial
	mov R0,R4	
	@FLDCNST	
	.long -1	
	mov R1,TEMP0	
	mov R2,#0	
	@FLDCNST	
	.long 4800	
	mov R3,TEMP0	
	@FCALL	
	.long _FdSerial_start	
	.dbline 37
; cogId = cognew(getData, &stack[49]); // Start a cog to run the parser
	@FLDCNST	
	.long _getData	
	mov R0,TEMP0	
	@FLDCNST	
	.long _stack+196	
	mov R1,TEMP0	
	@FCALL	
	.long _cognew	
	mov R15,R0	
	@FSTOREL	
	.long _cogId	
	.long R15	
	.dbline 38
; return cogId; // Return the id of the cog 
	@FLOADL	
	.long _cogId	
	.long R0	
	.dbline -2
L1:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r Pin 4 I
	.dbend
	.dbfunc e gpsStop _gpsStop fV
;             id -> R4
_gpsStop::
	@FENTER	
	.long R4,0	
	.dbline -1
	.dbline 42
; }
; 
; void gpsStop(void)
; {
	.dbline 45
; int id ;
; 
; id = cogId; // Move to local variable so it can process it
	@FLOADL	
	.long _cogId	
	.long R4	
	.dbline 46
; FdSerial_stop(); // Stop FD serial
	@FCALL	
	.long _FdSerial_stop	
	.dbline 47
; asm("cogstop %id"); // Stop the parser cog
	cogstop R4
	.dbline -2
L3:
	@FPOP	
	.long R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r id 4 I
	.dbend
	.dbfunc s getData _getData fV
;         rxByte -> <dead>
;       fieldNum -> <dead>
;       nemaCode -> HRSP+0
;              i -> R4
_getData:
	@FENTER	
	.long R4,R13,R14,R15,0	
	sub HRSP,#8	
	.dbline -1
	.dbline 50
; }
; static void getData()
; {
	add PC,#160	;Jump to L6
L8:
	.dbline 56
;   int i, fieldNum;
;   char rxByte;
;   char nemaCode[5];
;     while(1) // start the infinate string getting loop
;     {
;    	  while(FdSerial_rx() != '$'); // $ start of any nema string
L9:
	.dbline 56
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	cmp R15,#36	WZ
IF_NE	sub PC,#20	;Jump to L8
	.dbline 58
; 	
; 	  for(i = 0; i<5; i++)        // Get the nema code from the start of the string
	mov R4,#0	
L11:
	.dbline 59
; 	    {	  	 	  			  // Nema code is 1st 5 letters after $
	.dbline 60
; 	    nemaCode[i] = FdSerial_rx(); 
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R14,HRSP	
	mov R13,R4	
	add R13,R14	
	mov R15,R15	
	wrbyte R15,R13	
	.dbline 61
; 	    }
L12:
	.dbline 58
	add R4,#1	
	.dbline 58
	cmps R4,#5	WC
IF_B	sub PC,#44	;Jump to L11
	.dbline 62
; 	  if(memcmp("GPRMC", &nemaCode, 5) == 0) // check the string code - GPRMC
	@FLDCNST	
	.long L17	
	mov R0,TEMP0	
	mov R1,HRSP	
	mov R2,#5	
	@FCALL	
	.long _memcmp	
	mov R15,R0	WZ
IF_NE	add PC,#12	;Jump to L15
	.dbline 63
; 	   {
	.dbline 64
; 	   decodeGPRMC();// Call the GPRMC decode function	  
	@FCALL	
	.long _decodeGPRMC	
	.dbline 65
; 	   }
	add PC,#44	;Jump to L16
L15:
	.dbline 66
; 	  else if (memcmp("GPGGA", &nemaCode, 5) == 0)  // check the string code- GPGGA
	@FLDCNST	
	.long L20	
	mov R0,TEMP0	
	mov R1,HRSP	
	mov R2,#5	
	@FCALL	
	.long _memcmp	
	mov R15,R0	WZ
IF_NE	add PC,#8	;Jump to L18
	.dbline 67
; 	   {
	.dbline 68
; 	   decodeGPGGA();  // Call the GPGGA decode function
	@FCALL	
	.long _decodeGPGGA	
	.dbline 69
; 	   }   
L18:
L16:
	.dbline 70
;     }
L6:
	.dbline 54
	sub PC,#164	;Jump to L9
X0:
	.dbline -2
L4:
	add HRSP,#8	
	@FPOP	
	.long R15,R14,R13,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l rxByte 0 c
	.dbsym l fieldNum 0 I
	.dbsym l nemaCode 0 A[5:5]c
	.dbsym r i 4 I
	.dbend
	.dbfunc s decodeGPRMC _decodeGPRMC fV
;              i -> R6
;       fieldNum -> R4
;         rxByte -> R5
_decodeGPRMC:
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	.dbline -1
	.dbline 75
; 
;   }
; 
; static void decodeGPRMC(void)
; {
	.dbline 80
; int i, fieldNum;
; char rxByte;
; 
; 
;        i = 0;			   // zero our string index counter
	mov R6,#0	
	.dbline 81
; 	   fieldNum = 1;
	mov R4,#1	
	.dbline 82
; 	   rxByte = FdSerial_rx();	// give RxByte a value, should be the 1st ','
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R5,R15	
	rdlong PC,PC	
	.long L23	
L22:
	.dbline 85
; 			   			  
; 	   while(rxByte != '*')       //Repeat until end of nema string defined by *
; 	     {
	.dbline 87
; 	   
; 	     rxByte = FdSerial_rx(); // Get the 1st serial byte
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R5,R15	
	.dbline 88
; 	     if (rxByte == ',') // if its a field sperator char
	mov R15,R15	
	and R15,MASKFF	
	cmp R15,#44	WZ
IF_NE	add PC,#40	;Jump to L25
	.dbline 89
; 	   	    {
	.dbline 90
; 	   	    fieldNum++; // Increment the field data is going into 
	add R4,#1	
	.dbline 94
; 			
; 			// if its 4(lat) allow to appened e or w char or 6(long), dont reset
; 			// string counter i.
; 		    if ((fieldNum != 4) && (fieldNum != 6)) 
	cmp R4,#4	WZ
IF_E	add PC,#12	;Jump to L27
	cmp R4,#6	WZ
IF_E	add PC,#4	;Jump to L27
	.dbline 95
; 		      {
	.dbline 96
; 	   	      i = 0;
	mov R6,#0	
	.dbline 97
; 		      }
L27:
	.dbline 98
; 		    rxByte = FdSerial_rx(); // Get a new byte because we got a comma before
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R5,R15	
	.dbline 99
; 	   	    }
L25:
	.dbline 101
; 	   
; 	     switch (fieldNum) // Depending on what field we are in appened the string.
	cmp R4,#1	WZ
IF_E	add PC,#72	;Jump to L31
	cmp R4,#2	WZ
IF_E	rdlong PC,PC	
	.long L30	
	cmp R4,#3	WZ
IF_E	add PC,#80	;Jump to L33
	cmp R4,#4	WZ
IF_E	add PC,#100	;Jump to L34
	cmp R4,#5	WZ
IF_E	add PC,#120	;Jump to L35
	cmp R4,#6	WZ
IF_E	add PC,#140	;Jump to L36
	cmp R4,#7	WZ
IF_E	add PC,#160	;Jump to L37
	cmp R4,#8	WZ
IF_E	add PC,#180	;Jump to L38
	cmp R4,#9	WZ
IF_E	add PC,#200	;Jump to L39
	add PC,#220	;Jump to L29
L31:
	.dbline 104
; 	        {
; 	   	    case 1:
; 		       time[i] = rxByte; // Time field
	@FLDCNST	
	.long _time	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 105
; 			   break;
	add PC,#192	;Jump to L30
L33:
	.dbline 110
; 	        case 2:
; 		   	                    // Non usefull field
; 			   break;
; 		    case 3:
; 		       lat[i] = rxByte; // Lat field
	@FLDCNST	
	.long _lat	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 111
; 			   break;
	add PC,#164	;Jump to L30
L34:
	.dbline 113
; 		    case 4:
; 		       lat[i] = rxByte; // Lat E or W char
	@FLDCNST	
	.long _lat	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 114
; 			   break;
	add PC,#136	;Jump to L30
L35:
	.dbline 116
; 		    case 5:
; 		   	   lon[i] = rxByte; // Long field
	@FLDCNST	
	.long _lon	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 117
; 			   break;
	add PC,#108	;Jump to L30
L36:
	.dbline 119
; 		    case 6:
; 		       lon[i] = rxByte;	// Long N or S 	  	 	 
	@FLDCNST	
	.long _lon	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 120
; 			   break;
	add PC,#80	;Jump to L30
L37:
	.dbline 122
; 		    case 7:
; 		       speed[i] = rxByte; // Speed Field
	@FLDCNST	
	.long _speed	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 123
; 			   break;
	add PC,#52	;Jump to L30
L38:
	.dbline 125
; 		    case 8:
; 		       heading[i] = rxByte; // Heading Field
	@FLDCNST	
	.long _heading	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 126
; 			   break;
	add PC,#24	;Jump to L30
L39:
	.dbline 128
; 		    case 9:
; 		       date[i] = rxByte; // Date Stamp
	@FLDCNST	
	.long _date	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 129
; 			   break;
L29:
L30:
	.dbline 133
; 			 
; 		    }	 	 	 	 
; 		
; 	     i++; // Increment string counter
	add R6,#1	
	.dbline 135
; 	   
; 	     }
L23:
	.dbline 84
	mov R15,R5	
	and R15,MASKFF	
	cmp R15,#42	WZ
IF_NE	rdlong PC,PC	
	.long L22	
	.dbline -2
L21:
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r i 6 I
	.dbsym r fieldNum 4 I
	.dbsym r rxByte 5 c
	.dbend
	.dbfunc s decodeGPGGA _decodeGPGGA fV
;              i -> R6
;       fieldNum -> R4
;         rxByte -> R5
_decodeGPGGA:
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	.dbline -1
	.dbline 140
; 
; }  
; 
; static void decodeGPGGA(void)
; {
	.dbline 146
; 
; int i, fieldNum;
; char rxByte;
; 
; 
;        i = 0;			   // zero our string index counter
	mov R6,#0	
	.dbline 147
; 	   fieldNum = 1;
	mov R4,#1	
	.dbline 148
; 	   rxByte = FdSerial_rx();	// give RxByte a value, should be the 1st ','
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R5,R15	
	add PC,#192	;Jump to L42
L41:
	.dbline 151
; 			   			  
; 	   while(rxByte != '*')       //Repeat until end of nema string
; 	     {
	.dbline 154
; 	     
; 		 
; 	     rxByte = FdSerial_rx(); // get a new serial byte.
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R5,R15	
	.dbline 155
; 	     if (rxByte == ',') // if its comma field seperator
	mov R15,R15	
	and R15,MASKFF	
	cmp R15,#44	WZ
IF_NE	add PC,#24	;Jump to L44
	.dbline 156
; 	   	    {
	.dbline 157
; 	   	    fieldNum++; // invrement field number
	add R4,#1	
	.dbline 158
; 			i = 0; // reset string counter
	mov R6,#0	
	.dbline 159
; 		    rxByte = FdSerial_rx(); // get a new byte
	@FCALL	
	.long _FdSerial_rx	
	mov R15,R0	
	mov R5,R15	
	.dbline 160
; 	   	    }
L44:
	.dbline 162
; 	   
; 	     switch (fieldNum)
	cmp R4,#6	WZ
IF_E	add PC,#28	;Jump to L48
	cmp R4,#7	WZ
IF_E	add PC,#36	;Jump to L49
	cmp R4,#8	WZ
IF_E	add PC,#56	;Jump to L50
	cmp R4,#9	WZ
IF_E	add PC,#76	;Jump to L51
	add PC,#96	;Jump to L46
L48:
	.dbline 165
; 	        {
; 			case 6:
; 			  valid = rxByte; // Valid Field
	@FSTOREB	
	.long _valid	
	.long R5	
	.dbline 166
; 			  break;			
	add PC,#80	;Jump to L47
L49:
	.dbline 168
; 		    case 7:
; 		       sats[i] = rxByte; // Number of Sats in view
	@FLDCNST	
	.long _sats	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 169
; 			   break;
	add PC,#52	;Jump to L47
L50:
	.dbline 171
; 		    case 8:
; 		       horisontalAcc[i] = rxByte; // Horisontal Accuracy
	@FLDCNST	
	.long _horisontalAcc	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 172
; 			   break;
	add PC,#24	;Jump to L47
L51:
	.dbline 174
; 		    case 9:
; 		       alt[i] = rxByte; // Altitude field
	@FLDCNST	
	.long _alt	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,R15	
	wrbyte R5,R14	
	.dbline 175
; 			   break;
L46:
L47:
	.dbline 179
; 			 
; 		    }	 	 	 	 
; 		
; 	     i++; // Increment string counter
	add R6,#1	
	.dbline 181
; 	   
; 	     }
L42:
	.dbline 150
	mov R15,R5	
	and R15,MASKFF	
	cmp R15,#42	WZ
IF_NE	sub PC,#208	;Jump to L41
	.dbline -2
L40:
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r i 6 I
	.dbsym r fieldNum 4 I
	.dbsym r rxByte 5 c
	.dbend
	.dbfunc e getGpsValid _getGpsValid fI
_getGpsValid::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 187
; 
; 
; }
; 
; int getGpsValid(void)
; {
	.dbline 188
;  return valid-'0'; // Convert the ascii valid char to a int
	@FLOADB	
	.long _valid	
	.long R15	
	and R15,MASKFF	
	mov R0,R15	
	sub R0,#48	
	.dbline -2
L52:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsTime _getGpsTime fpc
_getGpsTime::
	.dbline -1
	.dbline 192
; }  
; 
; char* getGpsTime(void)
;   {
	.dbline 193
;   return time; // Return the ponter to the string time.
	@FLDCNST	
	.long _time	
	mov R0,TEMP0	
	.dbline -2
L53:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsTimeHours _getGpsTimeHours fI
;          array -> HRSP+0
_getGpsTimeHours::
	@FENTER	
	.long R14,R15,0	
	sub HRSP,#4	
	.dbline -1
	.dbline 198
;   }
;   
;   // TIME LAYOUT HHMMDD
; int getGpsTimeHours(void)
;   {
	.dbline 200
;   char array[3];
;   array[0]=time[0]; // Place 1st digit in array[0]
	@FLOADB	
	.long _time	
	.long R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 201
;   array[1]=time[1];// Place second digit in 2
	@FLOADB	
	.long _time+1	
	.long R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 202
;   array[2]=0; // add 0 terminator
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 204
;   
;   return atoi(array); // Return ascii to int of the array
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L54:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l array 0 A[3:3]c
	.dbend
	.dbfunc e getGpsTimeMin _getGpsTimeMin fI
;          array -> HRSP+0
_getGpsTimeMin::
	@FENTER	
	.long R14,R15,0	
	sub HRSP,#4	
	.dbline -1
	.dbline 208
;   }  
; 
;   int getGpsTimeMin(void)
;   {
	.dbline 210
;   char array[3]; 
;   array[0]=time[2]; // Move 3rd digit
	@FLOADB	
	.long _time+2	
	.long R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 211
;   array[1]=time[3]; // 4th digit
	@FLOADB	
	.long _time+3	
	.long R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 212
;   array[2]=0; // 0 terminator
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 214
;    
;   return atoi(array); // Return ascii to int of array
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L58:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l array 0 A[3:3]c
	.dbend
	.dbfunc e getGpsTimeSec _getGpsTimeSec fI
;          array -> HRSP+0
_getGpsTimeSec::
	@FENTER	
	.long R14,R15,0	
	sub HRSP,#4	
	.dbline -1
	.dbline 218
;   }  
;   
;   int getGpsTimeSec(void)
;   {
	.dbline 221
;   
;   char array[3];
;   array[0]=time[4];// move 5th digit
	@FLOADB	
	.long _time+4	
	.long R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 222
;   array[1]=time[5];// move 6th digit
	@FLOADB	
	.long _time+5	
	.long R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 223
;   array[2]=0; // 0 terminator
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 225
;   
;   return atoi(array); // convert to int
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L63:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l array 0 A[3:3]c
	.dbend
	.dbfunc e getGpsDate _getGpsDate fpc
_getGpsDate::
	.dbline -1
	.dbline 231
;   }  
; 
; //Date Format DDMMYY  
;   
; char* getGpsDate(void)
; {
	.dbline 232
; return (date); // Return pointer to the date array
	@FLDCNST	
	.long _date	
	mov R0,TEMP0	
	.dbline -2
L68:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsDay _getGpsDay fI
;          array -> HRSP+0
_getGpsDay::
	@FENTER	
	.long R14,R15,0	
	sub HRSP,#4	
	.dbline -1
	.dbline 237
; }
; 
;   
; int getGpsDay(void)
;   {
	.dbline 239
;   char array[3];
;   array[0]=date[0]; //Move digit 1
	@FLOADB	
	.long _date	
	.long R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 240
;   array[1]=date[1]; // move digit 2
	@FLOADB	
	.long _date+1	
	.long R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 241
;   array[2]=0;   // 0 Terminator
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 243
;   
;   return atoi(array); // Return as int
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L69:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l array 0 A[3:3]c
	.dbend
	.dbfunc e getGpsMonth _getGpsMonth fI
;          array -> HRSP+0
_getGpsMonth::
	@FENTER	
	.long R14,R15,0	
	sub HRSP,#4	
	.dbline -1
	.dbline 248
;   
;   }
;  
;  int getGpsMonth(void)
;   {
	.dbline 250
;   char array[3]; 
;   array[0]=date[2]; // Move digit 1
	@FLOADB	
	.long _date+2	
	.long R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 251
;   array[1]=date[3];// move digit 2
	@FLOADB	
	.long _date+3	
	.long R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 252
;   array[2]=0; // 0 terminator
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 254
;   
;   return atoi(array); // Return as int
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L73:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l array 0 A[3:3]c
	.dbend
	.dbfunc e getGpsYear _getGpsYear fI
;          array -> HRSP+0
_getGpsYear::
	@FENTER	
	.long R14,R15,0	
	sub HRSP,#4	
	.dbline -1
	.dbline 259
;   
;   } 
;    
; int getGpsYear(void)
;   {
	.dbline 261
;   char array[3];
;   array[0]=date[4]; // Move digit 1
	@FLOADB	
	.long _date+4	
	.long R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 262
;   array[1]=date[5]; // move digit 2
	@FLOADB	
	.long _date+5	
	.long R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 263
;   array[2]=0; // 0 termiator
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 265
;   
;   return atoi(array); // Return as int
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L78:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l array 0 A[3:3]c
	.dbend
	.dbfunc e getGpsLat _getGpsLat fpc
_getGpsLat::
	.dbline -1
	.dbline 269
;   
;   }
; char* getGpsLat(void)
;   {
	.dbline 270
;   return lat; // Return pointer to lat string
	@FLDCNST	
	.long _lat	
	mov R0,TEMP0	
	.dbline -2
L83:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLatDeg _getGpsLatDeg fI
_getGpsLatDeg::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 274
;   }  
;       
; int getGpsLatDeg(void)
;   {
	.dbline 275
;   return getDeg(lat); // Return the value of of lat degs as an int
	@FLDCNST	
	.long _lat	
	mov R0,TEMP0	
	@FCALL	
	.long _getDeg	
	mov R15,R0	
	.dbline -2
L84:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLatMin _getGpsLatMin fI
_getGpsLatMin::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 279
;   }
; 
; int getGpsLatMin(void)
;   {
	.dbline 280
;   return getMin(lat); //Return the value of lat min as an int
	@FLDCNST	
	.long _lat	
	mov R0,TEMP0	
	@FCALL	
	.long _getMin	
	mov R15,R0	
	.dbline -2
L85:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLatSec _getGpsLatSec fI
_getGpsLatSec::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 284
;   }
; 
; int getGpsLatSec(void)
;   {
	.dbline 285
;   return getDecSec(lat); // Return lat seconds as an int
	@FLDCNST	
	.long _lat	
	mov R0,TEMP0	
	@FCALL	
	.long _getDecSec	
	mov R15,R0	
	.dbline -2
L86:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLatDecMin _getGpsLatDecMin fD
_getGpsLatDecMin::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 289
;   }
;     
; float getGpsLatDecMin(void)
;   {
	.dbline 291
;   // Decimal Minute Example 52.4544'
;   return getDecMin(lat); // Return the decimal minutes
	@FLDCNST	
	.long _lat	
	mov R0,TEMP0	
	@FCALL	
	.long _getDecMin	
	mov R15,R0	
	.dbline -2
L87:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLong _getGpsLong fpc
_getGpsLong::
	.dbline -1
	.dbline 295
;   }
;   
; char* getGpsLong(void)
;   {
	.dbline 296
;   return lon; // Return pointer to Long String
	@FLDCNST	
	.long _lon	
	mov R0,TEMP0	
	.dbline -2
L88:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLongDeg _getGpsLongDeg fI
_getGpsLongDeg::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 300
;   }
; 
; int getGpsLongDeg(void)
;   {
	.dbline 301
;   return getDeg(lon); // Return Long Degrees
	@FLDCNST	
	.long _lon	
	mov R0,TEMP0	
	@FCALL	
	.long _getDeg	
	mov R15,R0	
	.dbline -2
L89:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLongMin _getGpsLongMin fI
_getGpsLongMin::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 305
;   }
;   
; int getGpsLongMin(void)  
;   {
	.dbline 306
;   return getMin(lon); // Return Long Min
	@FLDCNST	
	.long _lon	
	mov R0,TEMP0	
	@FCALL	
	.long _getMin	
	mov R15,R0	
	.dbline -2
L90:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLongSec _getGpsLongSec fI
_getGpsLongSec::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 310
;   }
;   
; int getGpsLongSec(void)
;   {
	.dbline 311
;   return getDecSec(lon); //Return Long Seconds
	@FLDCNST	
	.long _lon	
	mov R0,TEMP0	
	@FCALL	
	.long _getDecSec	
	mov R15,R0	
	.dbline -2
L91:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsLongDecMin _getGpsLongDecMin fD
_getGpsLongDecMin::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 315
;   }  
;   
; float getGpsLongDecMin(void)
;   {
	.dbline 317
;   // Dec min example 52.5466
;   return getDecMin(lon); // Return long dec minutes
	@FLDCNST	
	.long _lon	
	mov R0,TEMP0	
	@FCALL	
	.long _getDecMin	
	mov R15,R0	
	.dbline -2
L92:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsAlt _getGpsAlt fI
_getGpsAlt::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 321
;   }  
;         
; int getGpsAlt(void)
;   {
	.dbline 322
;   return atoi(alt); // Return alt as an interger ( unit Meters)
	@FLDCNST	
	.long _alt	
	mov R0,TEMP0	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L93:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsAltTenths _getGpsAltTenths fI
_getGpsAltTenths::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 326
;   }
; 
; int getGpsAltTenths(void)
;   {
	.dbline 327
;   return (alt[6]-'0'); // Return the 10ths of the altitude
	@FLOADB	
	.long _alt+6	
	.long R15	
	and R15,MASKFF	
	mov R0,R15	
	sub R0,#48	
	.dbline -2
L94:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsAltFloat _getGpsAltFloat fD
_getGpsAltFloat::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 331
;   }     
;  
; float getGpsAltFloat(void)
;   {
	.dbline 332
;   return atof(alt); // Return altitude as a float
	@FLDCNST	
	.long _alt	
	mov R0,TEMP0	
	@FCALL	
	.long _atof	
	mov R15,R0	
	.dbline -2
L96:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsHeadingDeg _getGpsHeadingDeg fI
_getGpsHeadingDeg::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 336
;   }
;     
; int getGpsHeadingDeg(void)
;   {
	.dbline 337
;   return atoi(heading); // Return interger value of heading
	@FLDCNST	
	.long _heading	
	mov R0,TEMP0	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L97:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsHeadingTenths _getGpsHeadingTenths fI
_getGpsHeadingTenths::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 341
;   }
; 
;   int getGpsHeadingTenths(void)
;   {
	.dbline 343
;    
;   return heading[4]-'0'; // return the tenths of the heading
	@FLOADB	
	.long _heading+4	
	.long R15	
	and R15,MASKFF	
	mov R0,R15	
	sub R0,#48	
	.dbline -2
L98:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsHeadingFloat _getGpsHeadingFloat fD
_getGpsHeadingFloat::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 349
;   
;   }
; 
;   
; float getGpsHeadingFloat(void)
; {
	.dbline 350
; return atof(heading); // Return heading as a float
	@FLDCNST	
	.long _heading	
	mov R0,TEMP0	
	@FCALL	
	.long _atof	
	mov R15,R0	
	.dbline -2
L100:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsSats _getGpsSats fI
_getGpsSats::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 354
; }
; 
; int getGpsSats(void)
;   {
	.dbline 355
;   return atoi(sats); // Return current number of satilites in view
	@FLDCNST	
	.long _sats	
	mov R0,TEMP0	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L101:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsSpeed _getGpsSpeed fI
_getGpsSpeed::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 361
;   }
;   
;     
;   
; int getGpsSpeed(void)
;   {
	.dbline 362
;   return atoi(speed);  // Return speed as an int unit Knots
	@FLDCNST	
	.long _speed	
	mov R0,TEMP0	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L102:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsSpeedTenths _getGpsSpeedTenths fI
_getGpsSpeedTenths::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 366
;   }
;   
; int getGpsSpeedTenths(void)
;   {
	.dbline 367
;   return speed[4]-'0'; // return 10ths of speed
	@FLOADB	
	.long _speed+4	
	.long R15	
	and R15,MASKFF	
	mov R0,R15	
	sub R0,#48	
	.dbline -2
L103:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e getGpsSpeedFloat _getGpsSpeedFloat fD
_getGpsSpeedFloat::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 371
;   }
;   
; float getGpsSpeedFloat(void)
;   {
	.dbline 372
;   return atof(speed); // return speed as float
	@FLDCNST	
	.long _speed	
	mov R0,TEMP0	
	@FCALL	
	.long _atof	
	mov R15,R0	
	.dbline -2
L105:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc s getDeg _getDeg fI
;            deg -> HRSP+0
;     decimalLoc -> R4
;         degInt -> R4
;         length -> R6
;          array -> R5
_getDeg:
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	sub HRSP,#4	
	mov R5,R0	
	.dbline -1
	.dbline 378
;   }
; 
; 
; 
; static int getDeg(char *array)
; {
	.dbline 383
;   char decimalLoc, length;
;   char deg[3];
;   int degInt;
;  
;   decimalLoc = charLoc(array, '.'); // Find the location of the Dec in string
	mov R0,R5	
	mov R1,#46	
	@FCALL	
	.long _charLoc	
	mov R15,R0	
	mov R4,R15	
	.dbline 384
;   length = strlen(array); // Find the length of the string
	mov R0,R5	
	@FCALL	
	.long _strlen	
	mov R15,R0	
	mov R6,R0	
	.dbline 385
; 		   switch(decimalLoc) 
	and R4,MASKFF	
	cmp R4,#3	WZ
IF_E	add PC,#20	;Jump to L110
	cmp R4,#4	WZ
IF_E	add PC,#56	;Jump to L113
	cmp R4,#5	WZ
IF_E	add PC,#104	;Jump to L116
	add PC,#160	;Jump to L107
L110:
	.dbline 389
; 		   	  {
; 			  // string always places deg(1 - 3 digits) min(2 digit) decimal
; 			   case 3: // if 1 digit deg, 
; 			   		deg[0] = 0;
	mov R15,#0	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 390
; 					deg[1] = 0;
	mov R15,#0	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 391
; 					deg[2] = array[0];
	rdbyte R15,R5	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
L113:
	.dbline 394
; 			  
; 			   case 4: // if two digit degree
; 			   		deg[0] = '0'; 
	mov R15,#48	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 395
; 					deg[1] = array[0];
	rdbyte R15,R5	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 396
; 					deg[2] = array[1];
	mov R15,R5	
	add R15,#1	
	rdbyte R15,R15	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 397
; 			   		break;
	add PC,#60	;Jump to L108
L116:
	.dbline 399
; 			   case 5: // if 3 digit degree
; 			   		deg[0] = array[0];
	rdbyte R15,R5	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 400
; 					deg[1] = array[1];
	mov R15,R5	
	add R15,#1	
	rdbyte R15,R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 401
; 					deg[2] = array[2];
	mov R15,R5	
	add R15,#2	
	rdbyte R15,R15	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 402
; 					break;
L107:
L108:
	.dbline 406
; 					
; 			  } 
; 			  
; 		degInt = atoi(deg); // convert to interger value
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R4,R0	
	.dbline 407
; 		if (array[length-1] == 'W' || array[length-1] == 'S') // if w or s make negitibe
	mov R15,R6	
	and R15,MASKFF	
	sub R15,#1	
	add R15,R5	
	rdbyte R15,R15	
	mov R15,R15	
	and R15,MASKFF	
	mov R15,R15	
	cmp R15,#87	WZ
IF_E	add PC,#8	;Jump to L121
	cmp R15,#83	WZ
IF_NE	add PC,#28	;Jump to L119
L121:
	.dbline 408
; 		{
	.dbline 409
; 		degInt *= -1;
	@FLDCNST	
	.long -1	
	mov R0,TEMP0	
	mov R1,R4	
	@FMUL32	
	mov R15,R0	
	mov R4,R0	
	.dbline 410
; 		}	  
L119:
	.dbline 411
;   return degInt; // return the deg interger.
	mov R0,R4	
	.dbline -2
L106:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l deg 0 A[3:3]c
	.dbsym r decimalLoc 4 c
	.dbsym r degInt 4 I
	.dbsym r length 6 c
	.dbsym r array 5 pc
	.dbend
	.dbfunc s getMin _getMin fI
;     decimalLoc -> R5
;            min -> HRSP+0
;          array -> R4
_getMin:
	@FENTER	
	.long R4,R5,R14,R15,0	
	sub HRSP,#4	
	mov R4,R0	
	.dbline -1
	.dbline 415
; }
; 
; static int getMin(char *array)
; {
	.dbline 419
;   int decimalLoc;
;   char min[3];
; 
;   decimalLoc = charLoc(array, '.'); // find the decimal
	mov R0,R4	
	mov R1,#46	
	@FCALL	
	.long _charLoc	
	mov R5,R0	
	.dbline 422
;   
;   // copy two chars in front of the decimal
;   min[2] = 0; // make last digit 0 term for string.
	mov R15,#0	
	mov R14,HRSP	
	add R14,#2
	wrbyte R15,R14	
	.dbline 423
;   min[1] = array[decimalLoc-1];
	mov R15,R5	
	sub R15,#1	
	add R15,R4	
	rdbyte R15,R15	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 424
;   min[0] = array[decimalLoc-2];
	mov R15,R5	
	sub R15,#2	
	add R15,R4	
	rdbyte R15,R15	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 426
; 
;   return atoi(min); // return number converted to string
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R15,R0	
	.dbline -2
L122:
	add HRSP,#4	
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r decimalLoc 5 I
	.dbsym l min 0 A[3:3]c
	.dbsym r array 4 pc
	.dbend
	.dbfunc s getDecMin _getDecMin fD
;         decMin -> HRSP+0
;          index -> R6
;         length -> R7
;     decimalLoc -> R4
;          array -> R5
_getDecMin:
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	sub HRSP,#12	
	mov R5,R0	
	.dbline -1
	.dbline 430
; }
; 
; static float getDecMin(char *array)
; {
	.dbline 435
;   int length, decimalLoc, index;
;   char decMin[10];
;   
;    //Find the location of the decimal point in the  
;   decimalLoc = charLoc(array, '.');
	mov R0,R5	
	mov R1,#46	
	@FCALL	
	.long _charLoc	
	mov R15,R0	
	mov R4,R0	
	.dbline 438
;   
;   // Get the length of the total string
;   length = strlen(array)-1; //Subtract 1 so we dont copy the NS or EW id char
	mov R0,R5	
	@FCALL	
	.long _strlen	
	mov R15,R0	
	sub R15,#1	
	mov R7,R15	
	.dbline 440
;   
;   index = decimalLoc - 2; // Move our start index back 2 places
	mov R6,R4	
	sub R6,#2	
	.dbline 442
;   // Starting at 2 digits in front of the decimal place 
;   for(decimalLoc -= 2; decimalLoc <= length; decimalLoc++) 
	sub R4,#2	
	@FCACHE	
	jmp #L129	
L126:
	.dbline 443
;   {
	.dbline 445
;    //Copy the correct digits from the array
;    decMin[decimalLoc - index] = array[decimalLoc];  
	mov R15,R4	
	sub R15,R6	
	mov R14,HRSP	
	add R15,R14	
	mov R14,R4	
	add R14,R5	
	rdbyte R14,R14	
	wrbyte R14,R15	
	.dbline 446
;   }
L127:
	.dbline 442
	add R4,#1	
L129:
	.dbline 442
	cmps R4,R7	WZ WC
IF_BE	jmp #L126
	@FNEXT	
	.dbline 449
;   
;   // return the floating point number of DecMin converting from string to float
;   return atof(decMin);
	mov R0,HRSP	
	@FCALL	
	.long _atof	
	mov R15,R0	
	.dbline -2
L125:
	add HRSP,#12	
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l decMin 0 A[10:10]c
	.dbsym r index 6 I
	.dbsym r length 7 I
	.dbsym r decimalLoc 4 I
	.dbsym r array 5 pc
	.dbend
	.dbfunc s getDecSec _getDecSec fI
;         decMin -> HRSP+0
;          index -> R6
;         length -> R7
;     decimalLoc -> R4
;          array -> R5
_getDecSec:
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	sub HRSP,#12	
	mov R5,R0	
	.dbline -1
	.dbline 454
; 
; }
; 
; static int getDecSec(char *array)
; {
	.dbline 459
;   int decimalLoc, length, index;
;   char decMin[10];
;   
;   //Find the location of the decimal
;   decimalLoc = charLoc(array, '.');
	mov R0,R5	
	mov R1,#46	
	@FCALL	
	.long _charLoc	
	mov R15,R0	
	mov R4,R0	
	.dbline 462
;   
;   //Get the length of the string 
;   length = strlen(array);
	mov R0,R5	
	@FCALL	
	.long _strlen	
	mov R15,R0	
	mov R7,R0	
	.dbline 465
;   
;   // Set our index point just behind the decimal
;   index = decimalLoc+1;
	mov R6,R4	
	add R6,#1	
	.dbline 469
;   
;   // Starting at 2 digits in front of the decimal place copy 
;   //to the new array one digit at a time
;   for(decimalLoc ++; decimalLoc <= length; decimalLoc++)
	add R4,#1	
	@FCACHE	
	jmp #L134	
L131:
	.dbline 470
;   {
	.dbline 471
;    decMin[decimalLoc - index] = array[decimalLoc];  
	mov R15,R4	
	sub R15,R6	
	mov R14,HRSP	
	add R15,R14	
	mov R14,R4	
	add R14,R5	
	rdbyte R14,R14	
	wrbyte R14,R15	
	.dbline 472
;   }
L132:
	.dbline 469
	add R4,#1	
L134:
	.dbline 469
	cmps R4,R7	WZ WC
IF_BE	jmp #L131
	@FNEXT	
	.dbline 475
;   
;   // return the interger value devided by 60.
;   return atoi(decMin)/60;
	mov R0,HRSP	
	@FCALL	
	.long _atoi	
	mov R1,#60	
	@FDIV32S	
	mov R15,R0	
	.dbline -2
L130:
	add HRSP,#12	
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l decMin 0 A[10:10]c
	.dbsym r index 6 I
	.dbsym r length 7 I
	.dbsym r decimalLoc 4 I
	.dbsym r array 5 pc
	.dbend
	.dbfunc s charLoc _charLoc fI
;          index -> R4
;     searchChar -> R1
;          array -> R5
_charLoc:
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 480
; 
; }
; 
; static int charLoc(char *array, char searchChar)
; {
	.dbline 484
; int index;
; 
; // search for the given character in a c_str array until we find the end or the 1st char
; for(index = 0; (array[index] !=  0) && (array[index] != searchChar); index++);
	mov R4,#0	
	add PC,#4	;Jump to L139
L136:
	.dbline 484
L137:
	.dbline 484
	add R4,#1	
L139:
	.dbline 484
	mov R15,R4	
	add R15,R5	
	rdbyte R15,R15	
	mov R15,R15	
	and R15,MASKFF	
	mov R15,R15	WZ
IF_E	add PC,#16	;Jump to L140
	mov R14,R1	
	and R14,MASKFF	
	cmp R15,R14	WZ
IF_NE	sub PC,#48	;Jump to L136
L140:
	.dbline 486
; // return the 1st occurance of the char, or last element number.
; return index;
	mov R0,R4	
	.dbline -2
L135:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r index 4 I
	.dbsym r searchChar 1 c
	.dbsym r array 5 pc
	.dbend
	.area bss(ram,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParser.c
	.align	4
_stack:
	.blkb 200
	.dbsym s stack _stack A[200:50]L
_alt:
	.blkb 8
	.dbsym s alt _alt A[8:8]c
_horisontalAcc:
	.blkb 5
	.dbsym s horisontalAcc _horisontalAcc A[5:5]c
_sats:
	.blkb 4
	.dbsym s sats _sats A[4:4]c
_date:
	.blkb 8
	.dbsym s date _date A[8:8]c
_heading:
	.blkb 8
	.dbsym s heading _heading A[8:8]c
_speed:
	.blkb 8
	.dbsym s speed _speed A[8:8]c
_lon:
	.blkb 12
	.dbsym s lon _lon A[12:12]c
_lat:
	.blkb 12
	.dbsym s lat _lat A[12:12]c
_valid:
	.blkb 1
	.dbsym s valid _valid c
_time:
	.blkb 8
	.dbsym s time _time A[8:8]c
	.align	4
_cogId:
	.blkb 4
	.dbsym s cogId _cogId I
	.align	4
_GPSPIN:
	.blkb 4
	.dbsym s GPSPIN _GPSPIN I
	.area lit(rom,rel)
L20:
	.byte 'G,'P,'G,'G,'A,0
L17:
	.byte 'G,'P,'R,'M,'C,0
