	.area text(rom,rel)
	.dbfile ..\..\..\..\..\..\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParserDemo.c
	.area lit(rom,rel)
	.align	4
_GPS_PIN::
	.long 0
	.dbfile C:\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParserDemo.c
	.dbsym e GPS_PIN _GPS_PIN I
	.area text(rom,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParserDemo.c
	.dbfunc e main _main fI
_main::
	sub HRSP,#20	
	.dbline -1
	.dbline 43
; /*
; GPS Demo
; 3/22/09
; By TJ Johnson
; 
; This program parses the avliable NEMA string data from a GPS unit and displays 
; it to the terminal at a baud of 57600. 
; 
; The terminal display is optimized for the PST terminal avliable from parallax's 
; website.
; 
; For use with the parallax GPS unit, the /raw pin should be connected to ground.
; 
; See end of file for MIT License.
; 
; */
; #include <propeller.h>
; #include <stdio.h>
; #include <stdarg.h>
; #include <asio.h>
; #include <string.h>
; #include "gpsParser.h"
; 
; 
; 
; // Global Constants
; const int GPS_PIN = 0;
; 
; // function prototypes
; char* validToString(int input);
; 
; 
; 
; 
; 
; // Global Variables
; 
; char validStr[10];
; 
; 
; //Main function
; main()
; {
	.dbline 44
; wait(80000000); // Wait a second before starting the program.
	@FLDCNST	
	.long 80000000	
	mov R0,TEMP0	
	@FCALL	
	.long _wait	
	.dbline 45
; asio_init(57600); // Start the terminal at 57600 baud.
	@FLDCNST	
	.long 57600	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_init	
	.dbline 47
; 
; gpsStart(GPS_PIN); // Start the gps driver
	@FLOADL	
	.long _GPS_PIN	
	.long R0	
	@FCALL	
	.long _gpsStart	
	rdlong PC,PC	
	.long L3	
L2:
	.dbline 49
; while(1) // Forever repeating loop
; {
	.dbline 52
; 
; 
; putchar(0); // clear the screen
	mov R0,#0	
	@FCALL	
	.long _putchar	
	.dbline 57
; 
; // Print each of the avliable data from the gps to the terminal.
; // The 13 is a CR return character, for use with the ICCV7 termial replace 13 
; // with '/n' for a new line command.
; printf("The date is : %d/%d/%d %c", getGpsMonth(),getGpsDay(), getGpsYear(), 13);
	@FCALL	
	.long _getGpsMonth	
	mov R15,R0	
	@FCALL	
	.long _getGpsDay	
	mov R14,R0	
	@FCALL	
	.long _getGpsYear	
	mov R13,R0	
	@FLDCNST	
	.long L5	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 58
; printf("The Time is : %d:%d:%d %c", getGpsTimeHours(),getGpsTimeMin(), getGpsTimeSec(), 13);
	@FCALL	
	.long _getGpsTimeHours	
	mov R15,R0	
	@FCALL	
	.long _getGpsTimeMin	
	mov R14,R0	
	@FCALL	
	.long _getGpsTimeSec	
	mov R13,R0	
	@FLDCNST	
	.long L6	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 59
; printf("The signal is : %d  - %s %c", getGpsValid(),validToString(getGpsValid()), 13);
	@FCALL	
	.long _getGpsValid	
	mov R15,R0	
	@FCALL	
	.long _getGpsValid	
	mov R14,R0	
	@FCALL	
	.long _validToString	
	mov R14,R0	
	@FLDCNST	
	.long L7	
	mov R13,TEMP0	
	mov TEMP5,HRSP	
	wrlong R13,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 60
; printf("The latitude in DMS is : %d %d' %d'' %c", getGpsLatDeg(),getGpsLatMin(), getGpsLatSec(), 13);
	@FCALL	
	.long _getGpsLatDeg	
	mov R15,R0	
	@FCALL	
	.long _getGpsLatMin	
	mov R14,R0	
	@FCALL	
	.long _getGpsLatSec	
	mov R13,R0	
	@FLDCNST	
	.long L8	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 61
; printf("The latitude in Deg Decimal Minutes is : %d %f %c", getGpsLatDeg(), getGpsLatDecMin(), 13);
	@FCALL	
	.long _getGpsLatDeg	
	mov R15,R0	
	@FCALL	
	.long _getGpsLatDecMin	
	mov R14,R0	
	@FLDCNST	
	.long L9	
	mov R13,TEMP0	
	mov TEMP5,HRSP	
	wrlong R13,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 62
; printf("The orginal string read was : %s %c", getGpsLat(), 13);
	@FCALL	
	.long _getGpsLat	
	mov R15,R0	
	@FLDCNST	
	.long L10	
	mov R14,TEMP0	
	mov TEMP5,HRSP	
	wrlong R14,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 63
; printf("The longitude in DMS is : %d %d' %d'' %c", getGpsLongDeg(),getGpsLongMin(), getGpsLongSec(), 13);
	@FCALL	
	.long _getGpsLongDeg	
	mov R15,R0	
	@FCALL	
	.long _getGpsLongMin	
	mov R14,R0	
	@FCALL	
	.long _getGpsLongSec	
	mov R13,R0	
	@FLDCNST	
	.long L11	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 64
; printf("The longitude in Deg Decimal Minutes is : %d %f %c", getGpsLongDeg(), getGpsLongDecMin(), 13);
	@FCALL	
	.long _getGpsLongDeg	
	mov R15,R0	
	@FCALL	
	.long _getGpsLongDecMin	
	mov R14,R0	
	@FLDCNST	
	.long L12	
	mov R13,TEMP0	
	mov TEMP5,HRSP	
	wrlong R13,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 65
; printf("The orginal string read was : %s %c", getGpsLong(), 13);
	@FCALL	
	.long _getGpsLong	
	mov R15,R0	
	@FLDCNST	
	.long L10	
	mov R14,TEMP0	
	mov TEMP5,HRSP	
	wrlong R14,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 67
; 
; printf("The speed(knots) is : %d.%d as a float : %f %c",getGpsSpeed(), getGpsSpeedTenths(),getGpsSpeedFloat(), 13);
	@FCALL	
	.long _getGpsSpeed	
	mov R15,R0	
	@FCALL	
	.long _getGpsSpeedTenths	
	mov R14,R0	
	@FCALL	
	.long _getGpsSpeedFloat	
	mov R13,R0	
	@FLDCNST	
	.long L13	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 68
; printf("The heading is : %d.%d as a float : %f %c", getGpsHeadingDeg(), getGpsHeadingTenths(),getGpsHeadingFloat(), 13);
	@FCALL	
	.long _getGpsHeadingDeg	
	mov R15,R0	
	@FCALL	
	.long _getGpsHeadingTenths	
	mov R14,R0	
	@FCALL	
	.long _getGpsHeadingFloat	
	mov R13,R0	
	@FLDCNST	
	.long L14	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 69
; printf("The altitude(meters) is : %d.%d as a float : %f %c", getGpsAlt(),getGpsAltTenths(),getGpsAltFloat(), 13);
	@FCALL	
	.long _getGpsAlt	
	mov R15,R0	
	@FCALL	
	.long _getGpsAltTenths	
	mov R14,R0	
	@FCALL	
	.long _getGpsAltFloat	
	mov R13,R0	
	@FLDCNST	
	.long L15	
	mov R12,TEMP0	
	mov TEMP5,HRSP	
	wrlong R12,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R14,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#12	
	wrlong R13,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#16	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 70
; printf("The number of sats in view is : %d %c", getGpsSats(), 13);
	@FCALL	
	.long _getGpsSats	
	mov R15,R0	
	@FLDCNST	
	.long L16	
	mov R14,TEMP0	
	mov TEMP5,HRSP	
	wrlong R14,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov R15,#13	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _printf	
	.dbline 75
; 
; 
; 
; // wait 1 second before clearing and updating the data.
; wait(80000000);
	@FLDCNST	
	.long 80000000	
	mov R0,TEMP0	
	@FCALL	
	.long _wait	
	.dbline 77
; 
; }
L3:
	.dbline 48
	rdlong PC,PC	
	.long L2	
X0:
	.dbline -2
L1:
	add HRSP,#20	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e validToString _validToString fpc
;          input -> R4
_validToString::
	@FENTER	
	.long R4,0	
	mov R4,R0	
	.dbline -1
	.dbline 88
; 
; 
; return 0;
; }
; 
; 
; 
; 
; 
; char* validToString(int input)
;   {
	.dbline 90
;   // This function simpily returns a string based on true or false result
;   if (input == 1) // if the signal is good, move valid to the string to be printed.
	cmp R4,#1	WZ
IF_NE	add PC,#36	;Jump to L18
	.dbline 91
;     {
	.dbline 92
; 	strcpy(validStr, "Valid"); // Copy the string
	@FLDCNST	
	.long _validStr	
	mov R0,TEMP0	
	@FLDCNST	
	.long L20	
	mov R1,TEMP0	
	@FCALL	
	.long _strcpy	
	.dbline 93
;     }
	add PC,#32	;Jump to L19
L18:
	.dbline 95
;   else // if the signal is not valid, move invalid to the string.
;     {
	.dbline 96
; 	strcpy(validStr, "Invalid"); // Copy the string
	@FLDCNST	
	.long _validStr	
	mov R0,TEMP0	
	@FLDCNST	
	.long L21	
	mov R1,TEMP0	
	@FCALL	
	.long _strcpy	
	.dbline 97
; 	}
L19:
	.dbline 99
; 	
; 	return validStr; // return the copied string.
	@FLDCNST	
	.long _validStr	
	mov R0,TEMP0	
	.dbline -2
L17:
	@FPOP	
	.long R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r input 4 I
	.dbend
	.area bss(ram,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\ParallaxGps\GpsParser\gpsParserDemo.c
_validStr::
	.blkb 10
	.dbsym e validStr _validStr A[10:10]c
	.area lit(rom,rel)
L21:
	.byte 'I,'n,'v,'a,'l,'i,'d,0
L20:
	.byte 'V,'a,'l,'i,'d,0
L16:
	.byte 'T,'h,'e,32,'n,'u,'m,'b,'e,'r,32,'o,'f,32,'s,'a
	.byte 't,'s,32,'i,'n,32,'v,'i,'e,'w,32,'i,'s,32,58,32
	.byte 37,'d,32,37,'c,0
L15:
	.byte 'T,'h,'e,32,'a,'l,'t,'i,'t,'u,'d,'e,40,'m,'e,'t
	.byte 'e,'r,'s,41,32,'i,'s,32,58,32,37,'d,46,37,'d,32
	.byte 'a,'s,32,'a,32,'f,'l,'o,'a,'t,32,58,32,37,'f,32
	.byte 37,'c,0
L14:
	.byte 'T,'h,'e,32,'h,'e,'a,'d,'i,'n,'g,32,'i,'s,32,58
	.byte 32,37,'d,46,37,'d,32,'a,'s,32,'a,32,'f,'l,'o,'a
	.byte 't,32,58,32,37,'f,32,37,'c,0
L13:
	.byte 'T,'h,'e,32,'s,'p,'e,'e,'d,40,'k,'n,'o,'t,'s,41
	.byte 32,'i,'s,32,58,32,37,'d,46,37,'d,32,'a,'s,32,'a
	.byte 32,'f,'l,'o,'a,'t,32,58,32,37,'f,32,37,'c,0
L12:
	.byte 'T,'h,'e,32,'l,'o,'n,'g,'i,'t,'u,'d,'e,32,'i,'n
	.byte 32,'D,'e,'g,32,'D,'e,'c,'i,'m,'a,'l,32,'M,'i,'n
	.byte 'u,'t,'e,'s,32,'i,'s,32,58,32,37,'d,32,37,'f,32
	.byte 37,'c,0
L11:
	.byte 'T,'h,'e,32,'l,'o,'n,'g,'i,'t,'u,'d,'e,32,'i,'n
	.byte 32,'D,'M,'S,32,'i,'s,32,58,32,37,'d,32,37,'d,39
	.byte 32,37,'d,39,39,32,37,'c,0
L10:
	.byte 'T,'h,'e,32,'o,'r,'g,'i,'n,'a,'l,32,'s,'t,'r,'i
	.byte 'n,'g,32,'r,'e,'a,'d,32,'w,'a,'s,32,58,32,37,'s
	.byte 32,37,'c,0
L9:
	.byte 'T,'h,'e,32,'l,'a,'t,'i,'t,'u,'d,'e,32,'i,'n,32
	.byte 'D,'e,'g,32,'D,'e,'c,'i,'m,'a,'l,32,'M,'i,'n,'u
	.byte 't,'e,'s,32,'i,'s,32,58,32,37,'d,32,37,'f,32,37
	.byte 'c,0
L8:
	.byte 'T,'h,'e,32,'l,'a,'t,'i,'t,'u,'d,'e,32,'i,'n,32
	.byte 'D,'M,'S,32,'i,'s,32,58,32,37,'d,32,37,'d,39,32
	.byte 37,'d,39,39,32,37,'c,0
L7:
	.byte 'T,'h,'e,32,'s,'i,'g,'n,'a,'l,32,'i,'s,32,58,32
	.byte 37,'d,32,32,45,32,37,'s,32,37,'c,0
L6:
	.byte 'T,'h,'e,32,'T,'i,'m,'e,32,'i,'s,32,58,32,37,'d
	.byte 58,37,'d,58,37,'d,32,37,'c,0
L5:
	.byte 'T,'h,'e,32,'d,'a,'t,'e,32,'i,'s,32,58,32,37,'d
	.byte 47,37,'d,47,37,'d,32,37,'c,0
